## a file with the initial guess for coordinates is passed 
## the program imcentroid is used to compute the accurate shift for
## each image

## The stars are found using starfind
procedure limalign (input, incoords, ocoords)

string input	   {"",prompt="List of input images"}
string incoords	   {"",prompt="File containing aproximate coordinates"}
string ocoords	   {"",prompt="File containing computed integer offsets"}
string ofshift     {"",prompt="File containing computed fractional offsets"}
string output 	   {"",prompt="List of successfully registered images"}
string ostars	   {"",prompt="List of stars used to register images"}
real psf	   {4,prompt="Value of the PSF - FWHM (pixels)"}
real threshold	   {5.,prompt="Threshold in sigma for object detections"}
#int cboxsize	   {9,prompt="Size of the centering box"}
string statsec	   {"",prompt="Image section to compute statistics"}
string	tmpdir	   {")_.tmpdir",prompt="Temporary directory for file conversion"}

string *list1	{prompt="Ignore this parameter(list1)"}
string *list2	{prompt="Ignore this parameter(list2)"}
string *list3	{prompt="Ignore this parameter(list3)"}

begin 

string imref,refcoo,inim,inli,outli
string ilist,tmpshifts,coorfile,censhift,ocrds,ofcrds
string dumm
real hpsf,athreshold,md,qua1,qua3
real xsh,ysh,xxsh,xxsh_int,xxsh_frac,yysh,yysh_int,yysh_frac,exxsh,eyysh
real xoff,yoff
real xcur,ycur
int npmin,boxsz,fsigma,nimag,ifs,nsc

hpsf = psf
#boxsz = int(psf*1.5+0.5)
boxsz = 15

coorfile = incoords

ocrds = ocoords
ofcrds = ofshift

inli = mktemp(tmpdir//"limlgninm")
sections(input,option="fullname",>inli)

if (output != "") 
  outli = output
else 
  outli = mktemp(tmpdir//"limlgnoutim")   

list1 = inli
ifs = fscan(list1,imref)

## search reference stars
## first compute statistics to determine detection threshold
imstatistics(imref//statsec,fields="midpt",format=no) | scan(md)
imstatistics(imref//statsec,fields="midpt",upper=md,lower=INDEF,format=no) | scan(qua1)
imstatistics(imref//statsec,fields="midpt",upper=INDEF,lower=md,format=no) | scan(qua3)

fsigma = threshold
athreshold = fsigma*(qua3 - qua1)/1.36
npmin = int(3.14*hpsf*hpsf+0.5)

refcoo = mktemp(tmpdir//"limlgn")

starfind(image = imref,             
        output = refcoo,      
       hwhmpsf = hpsf,              
     threshold = athreshold,           
       datamin = qua1,         
       datamax = 20000,          
       fradius = 2.5,            
        sepmin = 4.,            
       npixmin = npmin,             
         maglo = INDEF,          
         maghi = INDEF,          
       roundlo = 0.,             
       roundhi = 0.2,            
       sharplo = 0.5,            
       sharphi = 2.,             
           wcs = "",             
      wxformat = "",             
      wyformat = "",             
      boundary = "reflect",      
      constant = 0.,             
       nxblock = INDEF,          
       nyblock = 256,            
       verbose = no)    
       
ostars = refcoo

list1 = inli
list2 = coorfile
nimag = 1
while (fscan(list1,inim) != EOF) 
  {
    if (fscan(list2,xsh,ysh) == EOF)
      { 
	  print ("ERROR: missing initial shifts") 
	  bye
      }
	
    if (nimag > 1)  
      {
	 ilist = mktemp(tmpdir//"limlgnilst")
	 tmpshift = mktemp(tmpdir//"limlgntshft")
	 censhift = mktemp(tmpdir//"limlgncshft")
	 print(inim,>ilist)
	 print("inim=",inim)
	 xcur = xsh + xoff 
	 ycur = ysh + yoff
	 print(xcur,ycur,> tmpshift)
	 #print("xsh0,ysh0=",xsh,xcur,ysh,ycur)
	 imcentroid("@"//ilist,imref,refcoo,shifts=tmpshift,boxsize=boxsz,
	    background=INDEF,maxshift=INDEF,verb-,>censhift)
	 list3 = censhift   
	 while (fscan(list3,dumm) != EOF)
	   {
	     if (dumm == "#Shifts") 
	       {
	         ifs= fscanf(list3,"%s %f (%f) %f (%f)",dumm,xxsh,exxsh,yysh,eyysh)
		 nsc = nscan()
		 if (nsc > 0) { 
		   xoff = xxsh - xsh
		   yoff = yysh - ysh
		   xxsh_int = nint(xxsh) 
		   yysh_int = nint(yysh) 
		   xxsh_frac = nint((xxsh-xxsh_int)*100)/100.
		   yysh_frac = nint((yysh-yysh_int)*100)/100.
	           print(xxsh_int," ",yysh_int,>>ocrds)
		   if (ofcrds != "") 
		     print(xxsh_frac," ",yysh_frac, >>ofcrds) 		     		   
		   print(inim,>>outli)
	           print("xsh,ysh=",xxsh," ",yysh)
	         } else 
	           print("Warning: Shift cannot be determined for image ",inim)
	       } 
	   } 
	 delete(ilist,veri-)
	 delete(tmpshift,ver-)
      }
    else 
      {
         print(inim,>outli)
	 print(0," ",0,>ocrds)
	 if (ofcrds != "")
	    print(0," ",0,>ofcrds)
	 xoff = 0.
	 yoff = 0.
      }  
    nimag = nimag + 1  
  }
  
  
## clean up
delete(inli,ver-) 
delete("limlgncshft*",ver-)
delete("limlgn*",ver-)
bye

end  
