# laddwave - add approximate wavelength calibration 
# Author : Jose Acosta  (jap@ll.iac.es)
# Version: 01. May. 2007
#          
##############################################################################
procedure laddwave(input)
string	input		{prompt="List of comparison lamp spectra"}
int 	slitcenter	{INDEF,prompt=""}

string *list1	{prompt="Ignore this parameter"}


begin	
  string 	inli, im
  string	grkey
  real		cdelt, crval
  real		xoff=0	
  int		crpix, xslitcent1
  
  # expand input image list
  inli = mktemp("_lmswvclinput")	
  sections(input,option="fullname", >inli)
  
  ## start loop over slitlets
  
  xslitcent1 = slitcenter
  
  list1 = inli
  
  print("xslitcent ",xslitcent)
  if (xslitcent != INDEF) xoff = xslitcent1 - 512
  
  while (fscan(list1, im) != EOF) 
    {
  
	imgets(im,"lirgrnam")
	grkey = imgets.value
	
	lcentwave(grkey,xslitcent1)

        cdelt = lcentwave.cdelt
	crval = lcentwave.crval
	crpix = lcentwave.crpix
		  
        hedit(im,"CRVAL1",crval,add+,upd+,ver-,> "dev$null")
	hedit(im,"CD1_1",cdelt,add-,upd+,ver-,> "dev$null")
	hedit(im,"CDELT1",cdelt,add+,upd+,ver-,> "dev$null")
	hedit(im,"CRPIX1",crpix,add+,upd+,ver-,> "dev$null")

    } 
    
delete(inli,>> "dev$null")  
  
end  
  
  
 
