# imgaccess - checks if an image exists
# Author     : Robert Greimel (greimel@ing.iac.es)
# Last Change: 06. Aug. 2000
##############################################################################
procedure limgaccess(input)

file	input		{prompt="Input image"}
bool	exists		{no,prompt="does the file exists ?"}
string	real_name	{prompt="image file name with extension"}
bool	verbose		{no,prompt="Verbose ?"}

begin

  string	imgname,ext
  int		p,pos

  # copy input arguments to force definition at the beginning of the script
  imgname=input

  # default output values
  exists = no

  # find last "." in image name
  p = stridx( ".",imgname )
  pos = p
  while ( p != 0 && pos != strlen(imgname) )
    {
    p = stridx( ".",substr(imgname,pos+1,strlen(imgname)))
    pos = pos+p
    }

  # check if output image exists already
  # If an extension was part of the file name check if it is one of the
  # image formats. If not, try all common extensions.
  ext = ""
  if ( pos > 0 )
    {
    ext = substr(imgname,pos+1,strlen(imgname))
    if ( ext != "fit" && ext != "fits" && ext != "imh" )
      {
      ext = ""
      }
    }

  # (I should really check for fxf in imextn to find strange extensions ... )
  if ( ext == "" )
    {
    if (access(imgname//".fit"))
      {
      exists = yes
      real_name = imgname//".fit"
      }
    else if (access(imgname//".fits"))
      {
      exists = yes
      real_name = imgname//".fits"
      }
    else if (access(imgname//".imh"))
      {
      exists = yes
      real_name = imgname//".imh"
      }
    }
  else
    {
    if ( access(imgname) ) 
      { 
      exists = yes 
      real_name = imgname
      }
    }

  # print verbose infromation about our findings if it was asked for
  if ( verbose )
    {
    if ( exists ) 
      { 
      print "image "//imgname//" exists" 
      print "its complet name is "//real_name
      }
    else { print "image "//imgname//" does not exist" }
    }

end
